from jalon1.algos import *
from jalon1.equation import Equation

def testSubst():
    # On construit p_res a la main pour verifier 
    # subst(p, env)
    Y = TermVariable('Y')
    f_res = Predicate('f', [Y])
    f_res = TermPredicate(f_res)
    h_res = Predicate('h', [f_res, Y])
    h_res = TermPredicate(h_res)
    p_res = Predicate('p', [f_res, h_res, f_res])
    p_res = TermPredicate(p_res)
    print(f"Predicat attendu : {p_res}")


    Z = TermVariable('Z')
    W = TermVariable('W')
    f = Predicate('f', [W])
    f = TermPredicate(f)
    env = Environnement()
    env.addSubstitution(Z, f)
    env.addSubstitution(W, Y)
    h = Predicate('h', [Z, W])
    h = TermPredicate(h)
    p = Predicate('p', [Z, h, f])
    p = TermPredicate(p)
    print(f'Predicat avant subsitution : {p}\nEnvironnement : {env}')
    res = subst(p, env)
    print(f'Predicat apres substitution : {res}')
    

# traite un des cas de l'exo 7 de la question 1 a la question 4
def testUnify(n: int):
    u = TermVariable('u')
    w = TermVariable('w')
    x = TermVariable('x')
    y = TermVariable('y')
    z = TermVariable('z')
    a = Predicate('a', [])
    a = TermPredicate(a)
    b = Predicate('b', [])
    b = TermPredicate(b)
    fa = Predicate('f', [a])
    fa = TermPredicate(fa)
    fu = Predicate('f', [u])
    fu = TermPredicate(fu)
    fw = Predicate('f', [w])
    fw = TermPredicate(fw)
    fx = Predicate('f', [x])
    fx = TermPredicate(fx)
    fy = Predicate('f', [y])
    fy = TermPredicate(fy)
    fz = Predicate('f', [z])
    fz = TermPredicate(fz)
    gx = Predicate('g', [x])
    gx = TermPredicate(gx)
    gy = Predicate('g', [y])
    gy = TermPredicate(gy)
    gz = Predicate('g', [z])
    gz = TermPredicate(gz)
    hzw = Predicate('h', [z, w])
    hzw = TermPredicate(hzw)
    hyfa = Predicate('h', [y, fa])
    hyfa = TermPredicate(hyfa)
    fgy = Predicate('f', [gy])
    fgy = TermPredicate(fgy)
    
    match n:
        case 1:
            p1 = Predicate('p', [z, hzw, fw])
            p1 = TermPredicate(p1)
            p12 = Predicate('p', [fx, hyfa, y])
            p12 = TermPredicate(p12)
            e = Equation(p1, p12)    
        case 2:
            p2 = Predicate('p', [a, x, fgy])
            p2 = TermPredicate(p2)
            p22 = Predicate('p', [z, fz, fu])
            p22 = TermPredicate(p22)
            e = Equation(p2, p22)
        case 3:
            qyy = Predicate('q', [y, y])
            qyy = TermPredicate(qyy)
            qfg = Predicate('q', [fa, gx])
            qfg = TermPredicate(qfg)
            e = Equation(qfg, qyy)
        case 4:
            ffx = Predicate('f', [fx])
            ffx = TermPredicate(ffx)
            p4 = Predicate('p', [x, fx, ffx])
            p4 = TermPredicate(p4)
            ffy = Predicate('f', [fy])
            ffy = TermPredicate(ffy)
            p42 = Predicate('p', [ffy, y, fy])
            p42 = TermPredicate(p42)
            e = Equation(p4, p42)
    
    env=Environnement()
    e=SysEquation([e])
    print('\nequ:',e)
    print('env init:',env)
    env = unify(env, e)
    print('env final:',env,'\n')
